// GroupBoxExLib.h

#pragma once

using namespace System;
using namespace System::Windows::Forms;
using namespace System::Drawing;


namespace GroupBoxExLib {

	/* GroupBox~C ؤLo\, GgOnPaint */
	public ref class GroupBoxEx : public System::Windows::Forms::GroupBox{
		/* */
	private: Drawing::Color _BorderColor;
	public: property Drawing::Color BorderColor{
				Drawing::Color get(){
					return _BorderColor;
				}
				void set(Drawing::Color value){
					_BorderColor = value;
				}
			}

			/**/
			GroupBoxEx(){
				_BorderColor = Color::Blue;
			}
			/**/
			virtual void OnPaint(PaintEventArgs ^e) override {
				//otextrjp			
				Drawing::Size fontSize = TextRenderer::MeasureText(this->Text, this->Font);

				//eؽu			
				Drawing::Rectangle rec(e->ClipRectangle.Y,
					this->Font->Height / 2,
					e->ClipRectangle.Width - 1,
					(e->ClipRectangle.Height - 1 - this->Font->Height / 2));

				e->Graphics->DrawRectangle(gcnew Pen(BorderColor), rec);


				//textI
				e->Graphics->FillRectangle(gcnew SolidBrush(this->BackColor),
					Drawing::Rectangle(6, 0, fontSize.Width, fontSize.Height));

				//text			
				e->Graphics->DrawString(this->Text, this->Font, Pen(this->ForeColor).Brush, 6, 0);
			}

	};

}
